
Способ запуска
==============
Все написано на Python (тестировано на 2.7.5), так-же необходима установленная библиотека Tornado (версия 3.1.1 лежит в соответствующей папке)
Сервер принимает два параметра: port на котором он запускается и servers который содержит разделенный запятыми список всех остальных серверов

Пример
------
1 сервер: test.py --port=1337 --servers=127.0.0.1:1338
2 сервер: test.py --port=1338 --servers=127.0.0.1:1337


Архитектура
===========

Кратко о классах в приложении
-----------------------------

* class Subscription(object)
  маленький хелпер для обработки конкретной подписки (проверка потребности отсылки сообщения данному клиенту и сама отсылка)
* class Connection(object)
  принимает и обрабатывает комманды на каждом соединении
* class ClientConnection(Connection)
  содержит части, которые специфичные при работе с клиентами (не важно являются они клиентами или другими серверами)
* class RelayConnection(Connection)
  обработчик соединения от нас к удаленному серверу
* class QueueServer(TCPServer)
  главный объект сервера

Расширение протокола обмена
---------------------------

Мной добавлены пара дополнительных комманд, которые используются для синхронизации между серверами

* REGISTER_RELAY

* RELAY_MESSAGE
  RelayMessage := "RELAY_MESSAGE " MessageTag " " Message EOL
  MessageTag и Message определены так-же как и в SendMessage

Краткое описание работы
-----------------------

Сервер при запуске пытается подключиться ко всем указанным в параметрах серверам.
При установлении соединения он посылает им команду REGISTER_RELAY, чтобы зарегистрировать себя как получателя всех присылаемых сообщений.

При подключении обычного клиента создается объект ClientConnection, который обрабатывает команды, которые присылает клиент.
При приеме команды SUBSCRIBE создается объект Subscription, который занимается обработкой данной подписки и для упрощения храняший ссылку на stream к данному клиенту, чтобы сразу удобно отправить ему сообщение.
В частности данный объект осуществляет проверку необходимости посылки данного конкретного сообщения (т.е. тут можно реализовать проверку по регулярному выражению, или вообще подгрузку сторонней функции на какой-нибудь lua).
Хотя в этом простом случае взять какой-нибудь dict было бы быстрее, ибо там выборка подходящих клиентов будет не за O(n).

При приеме сообщения оно рассылается необходимым клиентам, а так-же, при помощи отдельной команды RELAY_MESSAGE оно отправляется всем остальным серверам на случай если к ним подключен клиент запросивщий получение данного сообщения.


